import com.baomidou.dynamic.datasource.annotation.DSTransactional;
import com.ruoyi.common.annotation.LogicIgnore;
import com.ruoyi.common.core.domain.BaseIdPo;
import com.ruoyi.framework.mybatis.holder.LogicHolder;
import com.sd.SdApplication;
import com.sd.business.entity.sku.po.Sku;
import com.sd.business.entity.sku.po.SkuSpecLink;
import com.sd.business.service.sku.SkuService;
import com.sd.business.service.sku.SkuSpecLinkService;
import lombok.SneakyThrows;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;

import java.util.List;
import java.util.stream.Collectors;

/**
 * 删除
 */
@RunWith(SpringRunner.class)
@SpringBootTest(classes = SdApplication.class, webEnvironment = SpringBootTest.WebEnvironment.DEFINED_PORT)
public class H1_RemoveSkuLinked {

    private static final Long A9_DEPARTMENT_ID = 1689164611148677121L;
    @Autowired
    private SkuService skuService;
    @Autowired
    private SkuSpecLinkService skuSpecLinkService;

    @LogicIgnore
    @SneakyThrows
    @DSTransactional
    @Test
    public void test() {
        LogicHolder.setLogicHolder(true);

        // 集团sku
        List<Sku> list = skuService.list(q -> q.eq(Sku::getType, 1));
        List<Long> skuIdList = list.stream().map(BaseIdPo::getId).collect(Collectors.toList());
        skuSpecLinkService.remove(q -> q.in(SkuSpecLink::getSkuId, skuIdList).ne(SkuSpecLink::getDepartmentId, 100L));

        // 非集团sku
        List<Sku> list2 = skuService.list(q -> q.eq(Sku::getType, 0));
        List<Long> skuIdList2 = list2.stream().map(BaseIdPo::getId).collect(Collectors.toList());
        skuSpecLinkService.remove(q -> q.in(SkuSpecLink::getSkuId, skuIdList2).ne(SkuSpecLink::getDepartmentId, A9_DEPARTMENT_ID));

        LogicHolder.setLogicHolder(false);
    }

}
